package Communication;

import com.google.protobuf.InvalidProtocolBufferException;
import meerkat.protobuf.DKGMessages;

/**
 * Created by Tzlil on 2/14/2016.
 */
public class MailHandler {

    private MessageHandler messageHandler;
    public MailHandler(MessageHandler messageHandler){
        this.messageHandler = messageHandler;
    }


    public void handel(DKGMessages.Mail mail) throws InvalidProtocolBufferException {
        switch (mail.getType()){
            case SECRET:
                DKGMessages.SecretMessage secretMessage = DKGMessages.SecretMessage.parseFrom(mail.getMessage());
                messageHandler.handelSecretMessage(mail.getSender(),mail.getDestination()== Network.BROADCAST,secretMessage);
                break;
            case COMMITMENT:
                DKGMessages.CommitmentMessage commitmentMessage = DKGMessages.CommitmentMessage.parseFrom(mail.getMessage());
                messageHandler.handelCommitmentMessage(mail.getSender(),mail.getDestination()== Network.BROADCAST,commitmentMessage);
                break;
            case DONE:
                DKGMessages.DoneMessage doneMessage = DKGMessages.DoneMessage.parseFrom(mail.getMessage());
                messageHandler.handelDoneMessage(mail.getSender(),mail.getDestination()== Network.BROADCAST,doneMessage);
                break;
            case COMPLAINT:
                DKGMessages.ComplaintMessage complaintMessage = DKGMessages.ComplaintMessage.parseFrom(mail.getMessage());
                messageHandler.handelComplaintMessage(mail.getSender(),mail.getDestination()== Network.BROADCAST,complaintMessage);
                break;
            case DOUBLE:
                DKGMessages.DoubleSecretMessage doubleSecretMessage = DKGMessages.DoubleSecretMessage.parseFrom(mail.getMessage());
                messageHandler.handelDoubleSecretMessage(mail.getSender(),mail.getDestination()== Network.BROADCAST,doubleSecretMessage);
            default:
                break;
        }
    }


    public MessageHandler getMessageHandler(){
        return messageHandler;
    }

    public void setMessageHandler(MessageHandler messageHandler) {
        this.messageHandler = messageHandler;
    }
}
